// Copyright (C) 2022 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

part of 'sign_up_cubit.dart';

class SignUpState extends Equatable {
  final Email email;
  final Password password;
  final FormStatus status;
  final FormData data;
  final String? errorMessage;

  const SignUpState({
    required this.data,
    this.email = const Email.pure(),
    this.password = const Password.pure(),
    this.status = FormStatus.pure,
    this.errorMessage,
  });

  SignUpState copyWith({
    Email? email,
    Password? password,
    FormStatus? status,
    FormData? data,
    String? errorMessage,
  }) =>
      SignUpState(
        email: email ?? this.email,
        password: password ?? this.password,
        status: status ?? this.status,
        data: data ?? this.data,
        errorMessage: errorMessage ?? this.errorMessage,
      );

  @override
  String toString() => 'SignUpState(email: $email, password: $password, '
      'status: $status, data: $data, errorMessage: $errorMessage)';

  @override
  List<Object?> get props => [email, password, status, data, errorMessage];
}
