// Copyright (C) 2022 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

import 'package:flutter/widgets.dart';
import 'package:flutter_bloc/flutter_bloc.dart';

abstract class BlocBaseProviderScreen<B extends BlocBase<S>, S extends Object>
    extends StatelessWidget {
  const BlocBaseProviderScreen({super.key});

  /// Creates the [Cubit] or [Bloc] to be used.
  B create(BuildContext context);

  /// Creates the child [Widget] to be used.
  Widget buildChild(BuildContext context);

  @override
  Widget build(BuildContext context) => BlocProvider<B>(
        create: (_) => create(context),
        child: Builder(builder: buildChild),
      );
}
